Subject: bug#64536: 30.0.50; Make cl-print put buttons on ellipses

From: Ihor Radchenko <[email-masked]>
Date: Mon, 14 Aug 2023 11:01:20 +0000

Stefan Monnier <[email-masked]> writes:

>> I am pretty sure that some uses of `backtrace-ellipsis' have nothing to
>> do with printing Elisp values.
>
> Could you expand on what makes you think so?

Theoretical backward-compatibility considerations.

> I grepped for it in Melpa and couldn't find any use of it at all, FWIW.

You are right. I also searched in
https://github.com/search?q=backtrace-ellipsis+language%3A%22Emacs+Lisp%22&type=code&l=Emacs+Lisp&p=1

And found nothing apart from Emacs forks and inspector.el.
So, it should likely be safe to remove this button.

>> At least, there is no reason why they should be limited to.
>
> It was rather tightly integrated with `cl-print`, tho:
> the button called `backtrace-expand-ellipsis` which itself looked for
> a `cl-print-ellipsis` text-property and called
> `cl-print-to-string-with-limit` and `cl-print-expand-ellipsis` on it.

I see. Another +1 to silent removal. I thought that is it less
specialized (given that its name is public).

>>>> May it be possible to create an obsolete alias for this button type?
>>> And I don't think we have such aliases.
>> May it be added?
>
> Patch welcome (especially if it comes together with some kind of
> obsolescence mechanism).

I am not sure if this can be done on byte compiler level.
For runtime, after skimming through button.el, it looks like
`button-category-symbol' might be used to throw a warning when obsolete
button type is being used.

-- 
Ihor Radchenko // yantar92,
Org mode contributor,
Learn more about Org mode at <https://orgmode.org/>.
Support Org development at <https://liberapay.com/org-mode>,
or support my work at <https://liberapay.com/yantar92>